<?php
namespace Teknisa\PED\Modules\Expedicao\Factories;

use Teknisa\PED\Controllers\TeknisaCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Request\Row;
use \Zeedhi\Framework\DataSource\ParameterBag;
use \Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use \Doctrine\ORM\EntityManager;
use \Teknisa\Libs\Util\DateUtil;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class Exp01800CancelamentoFactory {

    protected $dataSourceName = 'cancelamento';
    protected $newCode;
    protected $environment;
    protected $entityManager;

    public function __construct($crudService, $newCode, $environment, $entityManager) {
        $this->crudService = $crudService;
        $this->newCode = $newCode;
        $this->environment = $environment;
        $this->entityManager = $entityManager;
        $this->connection = $entityManager->getConnection();
    }

    public function cancelarNota($row) {
        try{
            // var_dump($row['NRLANCTONF'], $row['CDFILIAL']);
            $procedure = new StoredProcedure($this->connection, 'CANCELA_EXPEDICAO');
            $procedure->addParam(new Param('P_FILIAL',       Param::PARAM_INPUT,  $row['CDFILIAL']      , Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_LANCTONF',     Param::PARAM_INPUT,  $row['NRLANCTONF']    , Param::PARAM_TYPE_STR));
        
            return $procedure->execute();

        }catch (\Exception $e) {

            throw new \Exception($e);            

        }
    }
    
}